'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.LiveStatusIndicator = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _designLanguage = require('@jenkins-cd/design-language');

var _TimeHarmonizer = require('../components/TimeHarmonizer');

var _logging = require('../logging');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var logger = _logging.logging.logger('io.jenkins.blueocean.core.LiveStatusIndicator');

var LiveStatusIndicator = exports.LiveStatusIndicator = (0, _TimeHarmonizer.TimeHarmonizer)(_class = function (_Component) {
    _inherits(LiveStatusIndicator, _Component);

    function LiveStatusIndicator() {
        _classCallCheck(this, LiveStatusIndicator);

        return _possibleConstructorReturn(this, (LiveStatusIndicator.__proto__ || Object.getPrototypeOf(LiveStatusIndicator)).apply(this, arguments));
    }

    _createClass(LiveStatusIndicator, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                result = _props.result,
                getI18nTitle = _props.getI18nTitle;

            var title = getI18nTitle(result);
            logger.debug('i18n title', title);
            return _react2.default.createElement(
                'div',
                { title: title },
                _react2.default.createElement(_designLanguage.LiveStatusIndicator, this.props)
            );
        }
    }]);

    return LiveStatusIndicator;
}(_react.Component)) || _class;

LiveStatusIndicator.propTypes = {
    result: _react.PropTypes.string,
    percentage: _react.PropTypes.number,
    width: _react.PropTypes.string,
    height: _react.PropTypes.string,
    noBackground: _react.PropTypes.bool,
    startTime: _react.PropTypes.string,
    estimatedDuration: _react.PropTypes.number,
    durationInMillis: _react.PropTypes.number,
    getI18nTitle: _react.PropTypes.func
};
//# sourceMappingURL=LiveStatusIndicator.js.map
